@echo off

setlocal

set title=
set text=
set buttons=0
set icon=0
set defbutton=0
set modality=0

set _switch=/text

:loop

if "%1" equ "/?" goto help
if /i "%1" equ "/h" goto help
if /i "%1" equ "/help" goto help

if /i "%1" equ "/title" (
	set _switch=/title
) else if /i "%1" equ "/text" (
	set _switch=/text
) else if /i "%1" equ "OK" (
	set buttons=0
) else if /i "%1" equ "/OKCANCEL" (
	set buttons=1
) else if /i "%1" equ "/ABORTRETRYIGNORE" (
	set buttons=2
) else if /i "%1" equ "/YESNOCANCEL" (
	set buttons=3
) else if /i "%1" equ "/YESNO" (
	set buttons=4
) else if /i "%1" equ "/RETRYCANCEL" (
	set buttons=5
) else if /i "%1" equ "/ICONHAND" (
	set icon=16
) else if /i "%1" equ "/ICONERROR" (
	set icon=16
) else if /i "%1" equ "/ICONSTOP" (
	set icon=16
) else if /i "%1" equ "/ICONQUESTION" (
	set icon=32
) else if /i "%1" equ "/ICONEXCLAMATION" (
	set icon=48
) else if /i "%1" equ "/ICONWARNING" (
	set icon=48
) else if /i "%1" equ "/ICONASTERISK" (
	set icon=64
) else if /i "%1" equ "/ICONINFORMATION" (
	set icon=64
) else if /i "%1" equ "/DEFBUTTON1" (
	set defbutton=0
) else if /i "%1" equ "/DEFBUTTON2" (
	set defbutton=256
) else if /i "%1" equ "/DEFBUTTON3" (
	set defbutton=512
) else if /i "%1" equ "/DEFBUTTON4" (
	set defbutton=768
) else if /i "%1" equ "/APPLMODAL" (
	set modality=0
) else if /i "%1" equ "/SETFOREGROUND" (
	set modality=65536
) else if /i "%1" equ "/TOPMOST" (
	set modality=262144
) else (
	if /i "%_switch%" equ "/title" (
		set title=%title% %1
	) else (
		set text=%text% %1
	)
)

shift
if not "%1" equ "" goto loop

set /a flags=%buttons%+%icon%+%defbutton%+%modality%
if "%title%" equ "" set title=Message

anydll user32 MessageBox 0 /s "%text%" /s "%title:\"=%" /d %flags%

goto the_end

:help

echo Opens a message box and prints the result.
echo.
echo MSGBOX [/TITLE Title text] [/OK, /OKCANCEL, /ABORTRETRYIGNORE, /YESNOCANCEL, /YESNO, /RETRYCANCEL] [/ICONSTOP, /ICONQUESTION, /ICONEXCLAMATION, /ICONINFORMATION] [/DEFBUTTONn] [/TEXT] Message box text
echo.
echo    /TITLE		Show Title text in the message box' title
echo    /OK			Show an OK button
echo    /OKCANCEL		Show an OK and a Cancel button
echo    /ABORTRETRYIGNORE	Show an Abort, a Retry and an Ignore button
echo    /YESNOCANCEL		Show an Yes, a No and a Cancel button
echo    /YESNO		Show an Yes and a No button
echo    /RETRYCANCEL		Show a Retry and a Cancel button
echo    /ICONSTOP		Show a stop icon for an error message
echo    /ICONQUESTION	Show a question mark icon for a desicion
echo    /ICONEXCLAMATION	Show an exclamation mark icon for a warning
echo    /ICONINFORMATION	Show an information sign icon for an information
echo    /DEFBUTTONn		Use button n as default button
echo    /TEXT		The message box text is following
echo    Message box text	Show Message box text on the message box
echo.
echo Copyleft (c) 2006, Volker Birk
echo This program is under the GNU General Public License 2.0.
echo.

:the_end
